# MaxPlusLinear

Copyright
---------

Copyright 2020 Andrea Micheli and Muhammad Syifa’ul Mufid



License
-------

This software is released "as is" for non-profit scientific
experimentation and for the reproduction of the experiments of the
paper "Computation of the Transient in Max-PlusLinear Systems via
SMT-Solving".

Any other use is forbidden without explicit, written permission from
the authors.



MPL random generator
------------------------

The random problem genrator can be executed as follows.

- `python3 generate.py --dim <MPL matrix size> --fin <Finite elements per row>`


MPL k0 and c solver
----------------------

Installing the dependencies:

- Install Python 3 (http://python.org)
- Install PIP (https://pip.pypa.io/en/stable/installing/)
- Install pysmt (http://pysmt.org): `python3 -mpip install --pre pysmt`
- Install click: `python3 -mpip install click`
- Install at least an SMT solver: `pysmt-install --msat`, `pysmt-install --z3`, or `pysmt-install --yices`

Executing:

- `python3 generate.py --dim 10 --fin 5 > problem.txt`
- `python3 solver.py < problem.txt`

Options:

- Using a specific SMT solver (among the ones installed):
```
python3 solver.py --solver=<solver_name> < problem.txt`. For example: `python3 maxplus.py --solver=yices < problem.txt
```

- Show help and advanced options: `python3 solver.py --help`



Reproducing Experiments
-----------------------

All the problems and results used for the experimental evaluation are
in folder `benchmarks/FORMATS20`.

Each sub-folder corresponds to the size of the matrix and contains two
kind of files:

- `problem_<uuid>.txt` is the MPL problem itself

- `result_<uuid>.txt` is the result that the solver generated in our
   experiment for the problem with the same uuid

The script results.py in the benchmark folder can be used to construct
a CSV of the results and to plot the results in a subfolder.

The command:

```
python3 results.pt FORMATS20
```

will reproduce the plots we have in the paper in the FORMATS20/plots
folder.
